From 8ff9cbe29970a9db2141d084b6db32b9323bf40e Mon Sep 17 00:00:00 2001
From: Peter Gerber <peter@arbitrary.ch>
Date: Tue, 3 Jul 2018 19:52:32 +0000
Subject: [PATCH] setup-rwdev.sh: Only check first 1 GiB for zeros

As described in QubesOS/qubes-issues#3758, a VM may fail to start
if the volume is large. This because the whole volume is read to
ensure it's empty (=all zeros).

This changes limits the check to the first 1 GiB of the private
volume. As additional safety, a scan with blkid is done.

Fixes https://github.com/QubesOS/qubes-issues/issues/3758
---
 init/setup-rwdev.sh | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/init/setup-rwdev.sh b/init/setup-rwdev.sh
index 3796be5..c5db69e 100755
--- a/init/setup-rwdev.sh
+++ b/init/setup-rwdev.sh
@@ -3,13 +3,17 @@
 set -e
 
 dev=/dev/xvdb
+max_size=1073741824  # check at most 1 GiB
 
 if [ -e "$dev" ] ; then
     # The private /dev/xvdb device is present.
 
     # check if private.img (xvdb) is empty - all zeros
-    private_size_512=$(blockdev --getsz "$dev")
-    if head -c $(( private_size_512 * 512 )) /dev/zero | diff "$dev" - >/dev/null; then
+    private_size=$(( $(blockdev --getsz "$dev") * 512))
+    if [ $private_size -gt $max_size ]; then
+        private_size=$max_size
+    fi
+    if cmp --bytes $private_size "$dev" /dev/zero >/dev/null && { blkid -p "$dev" >/dev/null; [ $? -eq 2 ]; }; then
         # the device is empty, create filesystem
         echo "Virgin boot of the VM: creating private.img filesystem on $dev" >&2
         if ! content=$(mkfs.ext4 -m 0 -q "$dev" 2>&1) ; then